
/**
 * Active object to manage the "count up" timer
 * 
 * @author Jim Teresco
 */

import objectdraw.*;
import javax.swing.JLabel;
import java.text.DecimalFormat;

public class CountUpTimer extends ActiveObject
{
    
    // update frequency
    private static final int PAUSE_TIME = 25;
    
    // keeping track of start time
    private double startTime;
    
    // the JLabel we update
    private JLabel timerLabel;
    
    // instance variable to allow run method to know that
    // the stopTimer method was called
    private boolean running;
    
    public CountUpTimer(JLabel l) {
        
        startTime = System.currentTimeMillis();
        timerLabel = l;
        
        start();
    }
    
    public void run() {
        
        running = true;
        DecimalFormat df = new DecimalFormat("##0.0");
        while (running) {
            double elapsed = System.currentTimeMillis() - startTime;
            timerLabel.setText("Elapsed Time: " + df.format(elapsed/1000));
            pause(PAUSE_TIME);
        }
    }

    // call to stop the timer, obviously
    public void stopTimer() {
        
        running = false;
    }
}
