
/**
 * Class that periodically calls back to the WindowController
 * class to create new numbers for the game.
 * 
 * @author Jim Teresco
 */

import objectdraw.*;

public class NumberGenerator extends ActiveObject
{

    // pause between numbers being added
    private static final int PAUSE_BETWEEN_CALLS = 1500;
    
    // remember the class we'll call back to
    private NumberDragGame game;
    
    // are we still running?
    private boolean running;
    
    public NumberGenerator(NumberDragGame wc) {
        
        game = wc;
        start();
    }
    
    public void run() {
        
        running = true;
        while (running) {
            game.nextNumber();
            pause(PAUSE_BETWEEN_CALLS);
        }
    }
    
    public void stopGenerating() {
        
        running = false;
    }
}
